//+------------------------------------------------------------------+
//|                                                               XO |
//|                                                           mladen | 
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_levelcolor Gray

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern string ForSymbol        = "";
extern double BoxSize          = 25;
extern int    PriceCount       = 4;
extern int    Level            = 1;
extern color  TextColor        = Silver;
extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "XOarrows";
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Orange;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double Hi[];
double Lo[];
double ne[];
double no[];
double kr[];
double trend[];

//
//
//
//
//

string shortName;
string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);   
      SetIndexBuffer(0,kr); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,no); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,ne); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,Hi);
      SetIndexBuffer(4,Lo);
      SetIndexBuffer(5,trend);

      //
      //
      //
      //
      //
      
         PriceCount = MathMax(PriceCount,1);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="CalculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
            if (StringTrimLeft(StringTrimRight(ForSymbol))=="") ForSymbol=Symbol();
            SetLevelValue(0, 0);
            SetLevelValue(1, Level);
            SetLevelValue(2,-Level);

      //
      //
      //
      //
      //
      
   shortName = arrowsIdentifier+" "+ForSymbol+" "+timeFrameToString(timeFrame)+" XO ("+DoubleToStr(BoxSize,2)+")";
   IndicatorShortName(shortName);
   return(0);
}
int deinit()
{
   if (!calculateValue && ShowArrows) deleteArrows();
   ObjectDelete(arrowsIdentifier+":boxSize");
   ObjectDelete(arrowsIdentifier+":currentValue");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][2];
#define _kr 0
#define _no 1
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { kr[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
    
   if (calculateValue || (ForSymbol==Symbol() && timeFrame == Period()))
   {
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      double pipModifier = 1; if (Digits==3 || Digits==5) pipModifier=10;
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {         
         if (i>=(Bars-PriceCount-1)) { Hi[i]=Close[i]*PriceCount; Lo[i]=Close[i]*PriceCount; work[r][_no] = 0; work[r][_kr] = 0; continue; }

         //
         //
         //
         //
         //
      
         double cur = Close[i];
            for(int k=1; k<PriceCount; k++) cur += Close[i+k];
         Hi[i]        = Hi[i+1];
         Lo[i]        = Lo[i+1];
         kr[i]        = EMPTY_VALUE;
         no[i]        = EMPTY_VALUE;
         ne[i]        = EMPTY_VALUE;
         work[r][_no] = work[r-1][_no];
         work[r][_kr] = work[r-1][_kr];
         trend[i]     = 0;
            if (cur > (Hi[i]+BoxSize*pipModifier*Point)) { Hi[i] = cur; Lo[i] = cur-BoxSize*pipModifier*Point; work[r][_kr] += 1; work[r][_no] = 0; }
            if (cur < (Lo[i]-BoxSize*pipModifier*Point)) { Lo[i] = cur; Hi[i] = cur+BoxSize*pipModifier*Point; work[r][_no] -= 1; work[r][_kr] = 0; }
               if (work[r][_kr] >  Level) trend[i]= 1;
               if (work[r][_no] < -Level) trend[i]=-1;
               if (trend[i]== 1) kr[i] = work[r][_kr];
               if (trend[i]==-1) no[i] = work[r][_no];
               if (trend[i]== 0)
               {
                  if (work[r][_kr]>0) 
                        ne[i] = work[r][_kr]; 
                  else  ne[i] = work[r][_no]; 
               }
            manageArrow(i);
      }
      manageAlerts();
      manageDisplay();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars","",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         kr[i]    = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize,PriceCount,Level,TextColor,false,arrowsIdentifier,0,y);
         no[i]    = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize,PriceCount,Level,TextColor,false,arrowsIdentifier,1,y);
         ne[i]    = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize,PriceCount,Level,TextColor,false,arrowsIdentifier,2,y);
         trend[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize,PriceCount,Level,TextColor,false,arrowsIdentifier,5,y);
         manageArrow(i);
   }
   manageAlerts();
   manageDisplay();
   return(0);         
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageDisplay()
{
   if (!calculateValue)
   {
      int window = WindowFind(shortName);
      if (window==-1) return;
      string name = arrowsIdentifier+":boxSize";
         ObjectDelete(name);
         ObjectCreate(name,OBJ_LABEL,window,0,0);
            ObjectSet(name,OBJPROP_CORNER,1);
            ObjectSet(name,OBJPROP_XDISTANCE,10);
            ObjectSet(name,OBJPROP_YDISTANCE,10);
            ObjectSetText(name,"box size : "+DoubleToStr(BoxSize,1),8,"Arial",TextColor);
      name = arrowsIdentifier+":currentValue";
      double value = 0;
         if (kr[0]!=EMPTY_VALUE) value=kr[0];
         if (no[0]!=EMPTY_VALUE) value=no[0];
         if (ne[0]!=EMPTY_VALUE) value=ne[0];
         ObjectDelete(name);
         ObjectCreate(name,OBJ_LABEL,window,0,0);
            ObjectSet(name,OBJPROP_CORNER,1);
            ObjectSet(name,OBJPROP_XDISTANCE,10);
            ObjectSet(name,OBJPROP_YDISTANCE,22);
            ObjectSetText(name,"current value : "+DoubleToStr(value,1),8,"Arial",TextColor);
   }                  
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(timeFrameToString(timeFrame)+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," XO trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"XO "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (!calculateValue && ShowArrows && ForSymbol==Symbol())
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,139,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,139,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}